// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.
//#region Example
// This example shows how to read and display data of an attribute (value,
// timestamps, and status code).

class procedure Read.Main;
var
  Client: OpcLabs_EasyOpcUA_TLB._EasyUAClient;
  AttributeData: _UAAttributeData;
begin
  // Instantiate the client object
  Client := CoEasyUAClient.Create;

  WriteLn('Waiting for 1 seconds...');
  Sleep(1000);

  // Obtain attribute data. By default, the Value attribute of a node will be
  // read.
{
  AttributeData := Client.Read(
    'http://opcua.demo-this.com:51211/UA/SampleServer', // or 'opc.tcp://opcua.demo-this.com:51210/UA/SampleServer'
    'nsu=http://test.org/UA/Data/;i=10853');
}
  //EAK-Test / DNK/ 25.02.2019:
//DataDialog.EndpointDescriptor.UrlString := 'opc.tcp:/MAINLINE:4980/Softing_dataFEED_OPC_Suite_Configuration1';
  AttributeData := Client.Read(
    'opc.tcp://MAINLINE:4980/Softing_dataFEED_OPC_Suite_Configuration1',
//  's = Local Items.EAK_Test1.EAK_Testwert1_I4');   //=> Liefert Error: Falscher Node-Identifier!
//  'ns=4;s = Local Items.EAK_Test2.EAK_Testwert1_I4'); //=> Liefert Error!
//  'nsu=Local Items;ns=4;s=Local Items.EAK_Test2.EAK_Testwert1_I4'); //Funktioniert!
  'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert1_I4'); //Funktioniert auch (ns nicht ntig!) !!!

  // Display results
  WriteLn('Value: ', AttributeData.Value);
  WriteLn('ServerTimestamp: ', DateTimeToStr(AttributeData.ServerTimestamp));
  WriteLn('SourceTimestamp: ', DateTimeToStr(AttributeData.SourceTimestamp));
  WriteLn('StatusCode: ', AttributeData.StatusCode.ToString);

  // Example output:
  //
  //Value: -2.230064E-31
  //ServerTimestamp: 11/6/2011 1:34:30 PM
  //SourceTimestamp: 11/6/2011 1:34:30 PM
  //StatusCode: Good
end;
//#endregion Example
