// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.
//#region Example
// This example shows how to read the attributes of 4 OPC-UA nodes at once, and
// display the results.

class procedure ReadMultiple.Main;
var
  Arguments: OleVariant;
  Client: OpcLabs_EasyOpcUA_TLB._EasyUAClient;
  I: Cardinal;
  J, Jmax: Integer;
  log_createmultiple : Bool;
  zeitstempel_1,zeitstempel_2, delta_t: Cardinal;
  ReadArguments1, ReadArguments2, ReadArguments3, ReadArguments4: _UAReadArguments;
  Result: _UAAttributeDataResult;
  Results: OleVariant;
  //
  Url_String, NodeId_ExpandedText1, NodeId_ExpandedText2 : String;
  NodeId_ExpandedText3, NodeId_ExpandedText4: String;
  //
begin
  Url_String := 'opc.tcp://MAINLINE:4980/Softing_dataFEED_OPC_Suite_Configuration1';
  // 4x OPC-Items: TEST/DNK/25.02.2019:
  NodeId_ExpandedText1 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert1_I4';
  NodeId_ExpandedText2 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert3_R4';
  NodeId_ExpandedText3 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert5_String';
  NodeId_ExpandedText4 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert7_Bool';

  ReadArguments1 := CoUAReadArguments.Create;
//ReadArguments1.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//ReadArguments1.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;i=10853';
  ReadArguments1.EndpointDescriptor.UrlString := Url_String;
  ReadArguments1.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText1;

  ReadArguments2 := CoUAReadArguments.Create;
//ReadArguments2.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//ReadArguments2.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;i=10845';
  ReadArguments2.EndpointDescriptor.UrlString := Url_String;
  ReadArguments2.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText2;

  ReadArguments3 := CoUAReadArguments.Create;
//ReadArguments3.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//ReadArguments3.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;i=10304';
  ReadArguments3.EndpointDescriptor.UrlString := Url_String;
  ReadArguments3.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText3;

  ReadArguments4 := CoUAReadArguments.Create;
//ReadArguments4.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//ReadArguments4.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;i=10389';
  ReadArguments4.EndpointDescriptor.UrlString := Url_String;
  ReadArguments4.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText4;

  Arguments := VarArrayCreate([0, 3], varVariant);
  Arguments[0] := ReadArguments1;
  Arguments[1] := ReadArguments2;
  Arguments[2] := ReadArguments3;
  Arguments[3] := ReadArguments4;


  //Mehrfaches Create fr UA-Client-Objekt?
  log_createmultiple := true;

  // Instantiate the client object
  if (not log_createmultiple) then begin

     Client := CoEasyUAClient.Create;

     // Perform the operation
     TVarData(Results).VType := varArray or varVariant;
  end;

  Jmax := 10;
  WriteLn('Leseschleife Jmax:', IntToSTr(Jmax));

  for J := 1 to Jmax do begin
      // Instantiate the client object
      if (log_createmultiple) then begin

          Client := CoEasyUAClient.Create;

          // Perform the operation
          TVarData(Results).VType := varArray or varVariant;
      end;

      //
      zeitstempel_1 := GetTickCount;
      //
      TVarData(Results).VArray := PVarArray(Client.ReadMultiple(
          PSafeArray(TVarData(Arguments).VArray)));

      // Display results
      for I := VarArrayLowBound(Results, 1) to VarArrayHighBound(Results, 1) do
      begin
        Result := IInterface(Results[I]) as _UAAttributeDataResult;
        WriteLn('results(', I, ').AttributeData: ', Result.AttributeData.ToString);
      end;
      //
      Sleep(10); //50 ms-Test fr SPS/HIMA wichtig wegen Leckerkennung!
      //
      //Zeit-Messung:
      zeitstempel_2 := GetTickCount;
      //Zeitdifferenz
      delta_t := zeitstempel_2 - zeitstempel_1; //Millisekunden
      WriteLn('Index J:', IntToSTr(J), '   dt: ', delta_t);
  end;
  //TEST_Ergebnis /DNK/27.& 25.02.2019: Erfolgreich, alle 4 Werte sind korrekt!!!


  //2. Test-Beispiel mit DAtenknoten EAK_Test3 (100 Werte, 50x I4 & 50x R$)


//CoEasyUAClient.free;

end;
//#endregion Example
